
const OracleService = require('../service/OracleService')

class qryBaseCalcRedZModel {
    constructor() {
        this.GET_QRYBASECALCREDZ = `
            SELECT VRBCALCIMPRZ, VRIMPOSTORZ
              FROM IMPOSTOREDZ I, IMPOSTO O
             WHERE I.CDFILIAL     = :P_CDFILIAL
               AND I.CDCAIXA= :P_CDCAIXA
               AND I.DTREDUCAOZ   = :P_DTREDUCAOZ
               AND I.VRALIQIMPRZ  = :P_VRALIQIMPRZ
               AND I.CDIMPOSTO    = O.CDIMPOSTO
               AND O.IDTPIMPOSFIS = :P_IDTPIMPOSFIS
            UNION
            SELECT VRSTRIBREDZ, 0
              FROM REDUCAOZ
             WHERE CDFILIAL  = :P_CDFILIAL
               AND CDCAIXA   = :P_CDCAIXA
               AND DTREDUCAOZ= :P_DTREDUCAOZ
               AND :P_IDTPIMPOSFIS = 'F'
            UNION
            SELECT VRNINCIDREDZ, 0
              FROM REDUCAOZ
             WHERE CDFILIAL  = :P_CDFILIAL
               AND CDCAIXA   = :P_CDCAIXA
               AND DTREDUCAOZ= :P_DTREDUCAOZ
               AND :P_IDTPIMPOSFIS = 'N'
            UNION
            SELECT VRISENCREDZ, 0
              FROM REDUCAOZ
             WHERE CDFILIAL  = :P_CDFILIAL
               AND CDCAIXA   = :P_CDCAIXA
               AND DTREDUCAOZ= :P_DTREDUCAOZ
               AND :P_IDTPIMPOSFIS = 'I'
        `
    }
    get(params) {
        return OracleService.connect().then(sql => {
            return OracleService.execute(this.GET_QRYBASECALCREDZ, params);
        })
    }
}  

module.exports = new qryBaseCalcRedZModel();