
const OracleService = require('../service/OracleService')

class adqVerifLogOperFosModel {
    constructor() {
        this.GET_ADQVERIFLOGOPERFOS = `
            SELECT
               CDFILIAL, CDCAIXA, IDOPERFOS, CDOPERRESPOP,
               DTHROPERFOS
            FROM
               LOGOPERFOS
            WHERE
               (CDFILIAL     = :P_CDFILIAL    ) AND
               (CDCAIXA= :P_CDCAIXA     ) AND
               (IDOPERFOS    = :P_IDOPERFOS   ) AND
               (CDOPERRESPOP = :P_CDOPERRESPOP) AND
               (DTHROPERFOS  = TIMESTAMP :P_DTHROPERFOS )
        `
    }
    get(params) {
        return OracleService.connect().then(sql => {
            return OracleService.execute(this.GET_ADQVERIFLOGOPERFOS, params);
        })
    }
}  

module.exports = new adqVerifLogOperFosModel();