
const OracleService = require('../service/OracleService')

class adqVerifVendaItHrComandaModel {
    constructor() {
        this.GET_ADQVERIFVENDAITHRCOMANDA = `
            SELECT NRSEQVENDA
              FROM VENDA
             WHERE CDFILIAL  = :P_CDFILIAL
               AND CDCAIXA   = :P_CDCAIXA
               AND DTABERTUR = :P_DTABERTUR
                 AND ((NRSEQVENDAMSDE = :P_NRSEQVENDA) OR (NRVENDAREST = :P_NRVENDAREST))
        `
    }
    get(params) {
        return OracleService.connect().then(sql => {
            return OracleService.execute(this.GET_ADQVERIFVENDAITHRCOMANDA, params);
        })
    }
}  

module.exports = new adqVerifVendaItHrComandaModel();